// Moir without phase-shift
// 22 April 2014
//
// This software (macro) only runs in the Scilab 4.0 version
// You have to install in Scilab 4.0 the toolbox Siptoolbox and the best way is to install the ImageMagick
// The ImageMagick 6.2.5-5 Q16 Windows version is the one we use. http://www.imagemagick.org/script/binary-releases.php
// Before run this macro, you have to run the Siptoolbox
//
// Please, refer to this works if you use this macro in your work:
//
// R.A. Braga Jr., B.S. Oliveira, R.M. Costa, A.C.L. Lino, I.M. Dal Fabbro, 
// Suppression of border effects in moir techniques using three-dimensional methods, Biosystems Engineering, 
// 102, 1, 2009, 1-8, ISSN 1537-5110, http://dx.doi.org/10.1016/j.biosystemseng.2008.09.031.
// (http://www.sciencedirect.com/science/article/pii/S153751100800295X)
//
// R.M. Costa, R.A. Braga, B.S. Oliveira, E. Silva, T. Yanagi, J.T. Lima, 
// Sensitivity of the moir technique for measuring biological surfaces, Biosystems Engineering, 
// 100, 3, 2008, 321-328, ISSN 1537-5110, http://dx.doi.org/10.1016/j.biosystemseng.2008.04.011.
// (http://www.sciencedirect.com/science/article/pii/S1537511008001268)
// 
stacksize(4e7);
// Directory of where the images are in your computer
chdir('E:\Moire\');



//******************Read Grid Image - There is no phaseshift here **************
// Depending on the case the adoption of only one image is enough 
Grade1 = gray_imread('g1.tif');

//*********************Read Object***********************************

Objeto11 = gray_imread('objeto.tif'); 

//Subtraction of the images 
s1 = abs(Objeto11-Grade1);

//Gaussian filter to remove the grids. You should adjust the best level of filtering
Moire1 = gsm2d(s1,60);

// Saving the partial result
imwrite(Moire1,'Moire 2 1.jpg');

Topo_normal = 255*normal(Moire1);

Topo_normal = gsm2d(Topo_normal,20);           //Smoothing and denoising
filtro = mkfilter('circular-mean',15);         
Topo_normal = imconv(Topo_normal, filtro); 

//Saving the result
imwrite(normal(Topo_normal),'objeto_recuperado 1g.bmp');

//Ploting the result
Topo_normal=Topo_normal;

xset("window",1); xbasc();xselect();plot3d1(1:3:size(Topo_normal,'r'),1:3:size(Topo_normal,'c'),Topo_normal(1:3:$,1:3:$)); // 1:4 s modifica a visualizao do grfico
