// Moir with phase-shift
// 22 April 2014
//
// This software (macro) only runs in the Scilab 4.0 version
// You have to install in Scilab 4.0 the toolbox Siptoolbox and the best way is to install the ImageMagick
// The ImageMagick 6.2.5-5 Q16 Windows version is the one we use. http://www.imagemagick.org/script/binary-releases.php
// Before run this macro, you have to run the Siptoolbox
//
// Please, refer to this works if you use this macro in your work:
//
// R.A. Braga Jr., B.S. Oliveira, R.M. Costa, A.C.L. Lino, I.M. Dal Fabbro, 
// Suppression of border effects in moir techniques using three-dimensional methods, Biosystems Engineering, 
// 102, 1, 2009, 1-8, ISSN 1537-5110, http://dx.doi.org/10.1016/j.biosystemseng.2008.09.031.
// (http://www.sciencedirect.com/science/article/pii/S153751100800295X)
//
// R.M. Costa, R.A. Braga, B.S. Oliveira, E. Silva, T. Yanagi, J.T. Lima, 
// Sensitivity of the moir technique for measuring biological surfaces, Biosystems Engineering, 
// 100, 3, 2008, 321-328, ISSN 1537-5110, http://dx.doi.org/10.1016/j.biosystemseng.2008.04.011.
// (http://www.sciencedirect.com/science/article/pii/S1537511008001268)
// 
stacksize(4e7);
// Directory of where the images are in your computer
chdir('E:\Moire\');

//******************Read Grid Images with Phase-Shift**************

Grade1 = gray_imread('g1.tif');
Grade2 = gray_imread('g2.tif');
Grade3 = gray_imread('g3.tif');
Grade4 = gray_imread('g4.tif');
   
//*********************  Read Object  *****************************

Objeto11 = gray_imread('objeto.tif'); 

//Subtraction of the images 
s1 = abs(Objeto11-Grade1);
s2 = abs(Objeto11-Grade2);
s3 = abs(Objeto11-Grade3);
s4 = abs(Objeto11-Grade4);

//Gaussian filter to eliminate the grids. You should adjust the level of filtering.
Moire1 = gsm2d(s1,60);
Moire2 = gsm2d(s2,60);
Moire3 = gsm2d(s3,60);
Moire4 = gsm2d(s4,60);

imwrite(Moire1,'Moire1b ball.jpg');
imwrite(Moire2,'Moire2b ball.jpg');
imwrite(Moire3,'Moire3b ball.jpg');
imwrite(Moire4,'Moire4b ball.jpg');


//3D  Moir unwrap  
Empacotada = normal(imphase('bucket4a',0,Moire1,Moire2,Moire3,Moire4));  //Phase shifting


Topo = unwrapl(Empacotada);

Topo_normal = 255*normal(Topo); //255 levels of gray

Topo_normal = gsm2d(Topo_normal,20);           //Smoothing and denoising

//Saving the result
imwrite(normal(Topo_normal),'objeto_recuperadophsh ball.bmp');

//Ploting the result
Topo_normal=-Topo_normal;

xset("window",1); xbasc();xselect();plot3d1(1:4:size(Topo_normal,'r'),1:4:size(Topo_normal,'c'),Topo_normal(1:4:$,1:4:$)); 

